from __future__ import unicode_literals
import influxframework
from influxframework import _


def check_exceptions(model, error_message):
    if influxframework.session.user == "Administrator":
        return True

    if influxframework.has_permission(model["name"], model["action"]):
        has_permission = True

        if model["data"].owner != influxframework.session.user or model["short_name"] == "table":
            has_permission = False

            exceptions = influxframework.get_single("Restaurant Settings")
            profile = influxframework.db.get_value("User", influxframework.session.user, "role_profile_name")

            permissions = influxframework.db.get_list("Restaurant Exceptions", fields=(
                "order_write", "order_delete", "order_manage"
            ), filters={
                "role_profile": profile
            })

            if model["short_name"] == "order" and not exceptions.restricted_to_owner_order:
                has_permission = True

            if model["short_name"] == "table" and not exceptions.restricted_to_owner_table:
                has_permission = True

            for permission in permissions:
                if model["short_name"] == "order" and exceptions.restricted_to_owner_order:
                    has_permission = permission[f'{model["short_name"]}_{model["action"]}']

                if model["short_name"] == "table" and exceptions.restricted_to_owner_table:
                    has_permission = permission[f'{model["short_name"]}_{model["action"]}']

        if not has_permission:
            influxframework.throw(_(error_message))
    else:
        influxframework.throw(_("You do not have permissions to update " + model["short_name"]))

    return True
